Avaya Client Services API Reference (OS X)

- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

Instance Methods | Properties | List of all members
CSActiveParticipant Class Reference

Interface object representing an active participant in a conference call. More...

`#import <CSActiveParticipant.h>`

Inherits CSParticipant, and <NSCopying>.

## Instance Methods
(void) | - lowerHand:completionHandler:
| Lowers a participant's hand on the conference call. More...
(void) | - muteWithCompletionHandler:
| Mutes a participant on the call. More...
(void) | - unmuteWithCompletionHandler:
| Unmutes a participant on the call. More...
(void) | - blockVideoWithCompletionHandler:
| Blocks a participant's video on the call. More...
(void) | - unblockVideoWithCompletionHandler:
| Unblocks a participant's video on the call. More...
(void) | - initiateCameraControl:completionHandler:
| Initiates a remote camera control command. More...
(void) | - assignAsModeratorWithCompletionHandler:
| Used by a conference moderator to select a participant to be a moderator during the conference call. More...
(void) | - unassignAsModeratorWithCompletionHandler:
| Used by a conference moderator to select a participant to no longer be a moderator during the conference call. More...
(void) | - assignAsPresenterWithCompletionHandler:
| Used by a conference moderator to select a participant to be a presenter during the conference call. More...
(void) | - unassignAsPresenterWithCompletionHandler:
| Used by a conference moderator to select a participant to no longer be a presenter during the conference call. More...
(void) | - assignAsLecturerWithCompletionHandler:
| Used by a conference moderator to select a participant to be a lecturer during the conference call. More...
(void) | - unassignAsLecturerWithCompletionHandler:
| Used by a conference moderator to select a participant to no longer be a lecturer during the conference call. More...
(void) | - pinVideoWithDestinationPoint:completionHandler:
| Requests for current participant's video to be pinned in a certain area of the video image. More...
Instance Methods inherited from CSParticipant
(instancetype) | - initWithParticipantId:
(CSContact *) | - bestContactMatch
| Return best possible contact match. More...
(NSDictionary *) | - allPossibleContactMatches
| Return all possible contact matches with level of matching. More...
(void) | - sendPrivateChatMessage:completionHandler:
| Sends private message to this participant. More...

## Properties
id< CSActiveParticipantDelegate > | delegate
| The delegate used to handle active participant related events. More...
BOOL | audioMutedByServer
| Whether the participant's audio is muted. More...
BOOL | audioActive
| Whether the participant's audio is active. More...
CSParticipantMediaStatus | audioStatus
| Participant audio state, as known by the conferencing system. More...
CSParticipantConnectionStatus | connectionStatus
| Participant connection state, as known by the conferencing system. More...
BOOL | videoActive
| Whether the participant's video is active. More...
BOOL | applicationSharingActive
| Whether the participant's web collaboration is active. More...
BOOL | handRaised
| Whether the participant's hand is raised. More...
NSDate * | handRaisedDate
| The time participant has raised hand. More...
NSDate * | handLoweredDate
| The time participant has lowered hand. More...
BOOL | videoBlockedByServer
| Participant's video block (i.e., transmission) status, as known by the conferencing system. More...
CSParticipantMediaStatus | videoStatus
| Participant video state, as known by the conferencing system. More...
int | videoChannelId
| Video channel id associated with the video participant during a multi video stream conference call. More...
BOOL | moderator
| Whether the participant is a moderator. More...
BOOL | presenter
| Whether the participant is a presenter. More...
BOOL | lecturer
| Whether the participant is a lecturer. More...
BOOL | cameraRemoteControllable
| Whether the participant's camera is controllable. More...
NSDate * | lastSpokenDate
| Last time the participant was an active talker on the conference call. More...
NSDate * | enterDate
| Participant's entry time to the conference. More...
CSCapability * | lowerParticipantHandCapability
| CSCapability object indicating whether lowering another participant's hand is supported. More...
CSCapability * | lowerParticipantHandAndUnmuteAudioCapability
| CSCapability object indicating whether local user can lower participant's hand and unmute audio. More...
CSCapability * | muteParticipantAudioCapability
| CSCapability object indicating whether mute of a selected participant is supported. More...
CSCapability * | unmuteParticipantAudioCapability
| CSCapability object indicating whether unmute of a selected participant is supported. More...
CSCapability * | blockParticipantVideoCapability
| CSCapability object indicating whether block video of a selected participant is supported. More...
CSCapability * | unblockParticipantVideoCapability
| CSCapability object indicating whether unblock video of a selected participant is supported. More...
CSCapability * | cameraRemoteControlCapability
| CSCapability object indicating whether pan/tilt/zoom (PTZ) of the participant's camera can be controlled programmatically. More...
CSCapability * | assignAsLecturerCapability
| CSCapability object indicating whether selecting a participant as the conference lecturer is supported. More...
CSCapability * | assignAsModeratorCapability
| CSCapability object indicating whether selecting a participant as the conference moderator is supported. More...
CSCapability * | assignAsPresenterCapability
| CSCapability object indicating whether selecting a participant as the conference presenter is supported. More...
CSCapability * | unassignAsPresenterCapability
| CSCapability object indicating whether deselecting a participant as the conference presenter is supported. More...
CSCapability * | unassignAsLecturerCapability
| Returns whether local user can unassign a participant as a lecturer. More...
CSCapability * | inConferencePrivateChatCapability
| Returns whether the user supports private chat in conference. More...
CSCapability * | videoPinCapability
| CSCapability object indicating whether the local user can pin current participant's video in a specific position of the current video layout. More...
BOOL | restrictedParticipant
| A Boolean value indicating whether the participant has limited capabilities on the call. More...
BOOL | wasPreviouslyNotVisibleInParticipantList
| A Boolean value indicating that the active participant was on the conference but previously not visible in the conference roster. More...
Properties inherited from CSParticipant
id< CSParticipantDelegate > | delegate
| The delegate used to handle participant events, common to all participant subclasses. More...
NSString * | displayName
| Participant's network provided display name, as known to the conferencing system. More...
NSString * | address
| Participant's network-provided address, as known to the conferencing system. More...
BOOL | localUser
| Whether the participant is the local user. More...
NSString * | participantId
| Unique identification of the participant. More...

## Detailed Description

Interface object representing an active participant in a conference call.

## Method Documentation

- (void) assignAsLecturerWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to be a lecturer during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) assignAsModeratorWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to be a moderator during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) assignAsPresenterWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to be a presenter during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) blockVideoWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Blocks a participant's video on the call.

The local user must be a moderator for this operation to complete successfully.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) initiateCameraControl: |  | (CSCameraControl) | control
completionHandler: |  | (void(^)(NSError *error)) | handler

Initiates a remote camera control command.

If the far-end camera does not support remote camera commands, the command fails.

Parameters

  control | Camera control command
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) lowerHand: |  | (BOOL) | unmuteAudio
completionHandler: |  | (void(^)(NSError *error)) | handler

Lowers a participant's hand on the conference call.

The local user must be a moderator for this operation to complete successfully.

Parameters

  unmuteAudio | Indication as to whether the participant whose hand is lowered is to be unmuted.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) muteWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Mutes a participant on the call.

The local user must be a moderator for this operation to complete successfully.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) pinVideoWithDestinationPoint: |  | (CGPoint) | destinationPoint
completionHandler: |  | (void(^)(NSError *error)) | handler

Requests for current participant's video to be pinned in a certain area of the video image.

The destination coordinates can be any point within a video region inside the video image. They do not have to be a point at the boundary of the video region. In order to undo a previous video pin operation, the application needs to call setVideoLayout:completionHandler: (CSConference) and specify CSVideoLayoutDynamic layout option.

Parameters

  destinationPoint | Coordinates of the participant's final video position in the video image. The values are in the range 0.0 to 1.0, with 0, 0 referring to the upper left of the video image.
  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

See also
  CSActiveParticipant::videoPinCapability

- (void) unassignAsLecturerWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to no longer be a lecturer during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unassignAsModeratorWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to no longer be a moderator during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unassignAsPresenterWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Used by a conference moderator to select a participant to no longer be a presenter during the conference call.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unblockVideoWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Unblocks a participant's video on the call.

The local user must be a moderator for this operation to complete successfully.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

- (void) unmuteWithCompletionHandler: |  | (void(^)(NSError *error)) | handler |

Unmutes a participant on the call.

The local user must be a moderator for this operation to complete successfully.

Parameters

  handler | A block to be called when the operation is completed. `error` If the operation was successful this parameter is nil. If an error occurred it contains an object describing the error.

## Property Documentation

- (BOOL) applicationSharingActive
| read nonatomic assign

Whether the participant's web collaboration is active.

- (CSCapability*) assignAsLecturerCapability
| read nonatomic assign

CSCapability object indicating whether selecting a participant as the conference lecturer is supported.

The CSCapability returns not supported if the conference call does not support selection of a participant as the lecturer, or if the local user does not have permission to assign a participant as the lecturer on the call. Conference moderation capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (CSCapability*) assignAsModeratorCapability
| read nonatomic assign

CSCapability object indicating whether selecting a participant as the conference moderator is supported.

The CSCapability returns not supported if the conference call does not support selection of a participant as the moderator, or if the local user does not have permission to assign a participant as the moderator on the call. Conference moderation capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (CSCapability*) assignAsPresenterCapability
| read nonatomic assign

CSCapability object indicating whether selecting a participant as the conference presenter is supported.

The CSCapability returns not supported if the conference call does not support selection of a participant as the presenter, or if the local user does not have permission to assign or unassign a participant as the presenter on the call. Conference moderation capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (BOOL) audioActive
| read nonatomic assign

Whether the participant's audio is active.

- (BOOL) audioMutedByServer
| read nonatomic assign

Whether the participant's audio is muted.

- (CSParticipantMediaStatus) audioStatus
| read nonatomic assign

Participant audio state, as known by the conferencing system.

- (CSCapability*) blockParticipantVideoCapability
| read nonatomic assign

CSCapability object indicating whether block video of a selected participant is supported.

Conference video capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (CSCapability*) cameraRemoteControlCapability
| read nonatomic assign

CSCapability object indicating whether pan/tilt/zoom (PTZ) of the participant's camera can be controlled programmatically.

Conference video capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (BOOL) cameraRemoteControllable
| read nonatomic assign

Whether the participant's camera is controllable.

- (CSParticipantConnectionStatus) connectionStatus
| read nonatomic assign

Participant connection state, as known by the conferencing system.

- (id<CSActiveParticipantDelegate>) delegate
| read write nonatomic weak

The delegate used to handle active participant related events.

- (NSDate*) enterDate
| read nonatomic assign

Participant's entry time to the conference.

- (NSDate*) handLoweredDate
| read nonatomic assign

The time participant has lowered hand.

Returns
  null if hand is raised or never lowered

- (BOOL) handRaised
| read nonatomic assign

Whether the participant's hand is raised.

- (NSDate*) handRaisedDate
| read nonatomic assign

The time participant has raised hand.

Returns
  null if hand is lowered or never raised

- (CSCapability*) inConferencePrivateChatCapability
| read nonatomic assign

Returns whether the user supports private chat in conference.

- (NSDate*) lastSpokenDate
| read nonatomic assign

Last time the participant was an active talker on the conference call.

- (BOOL) lecturer
| read nonatomic assign

Whether the participant is a lecturer.

- (CSCapability*) lowerParticipantHandAndUnmuteAudioCapability
| read nonatomic assign

CSCapability object indicating whether local user can lower participant's hand and unmute audio.

This capability is Allowed if all of the following are true:

- The conference call supports raise hand feature.
- The local user has permission to lower another participant's hand.
- Participant's hand is raised.
- Participant's audio is muted by moderator.

Conference moderation features are not supported when the client is used in shared control mode.

See also
  lowerParticipantHandCapability:

Returns
  A CSCapability object.

- (CSCapability*) lowerParticipantHandCapability
| read nonatomic assign

CSCapability object indicating whether lowering another participant's hand is supported.

Lower participant hand capability is not supported when the client is used in shared control mode. See CSSharedControlService.

- (BOOL) moderator
| read nonatomic assign

Whether the participant is a moderator.

- (CSCapability*) muteParticipantAudioCapability
| read nonatomic assign

CSCapability object indicating whether mute of a selected participant is supported.

- (BOOL) presenter
| read nonatomic assign

Whether the participant is a presenter.

- (BOOL) restrictedParticipant
| read nonatomic assign

A Boolean value indicating whether the participant has limited capabilities on the call.

Restricted participant cannot be lecturer or presenter and cannot become a normal participant. Restricted participant has no moderator controls and can only have a single receive-only video stream. Restricted participant cannot unblock camera and send video, or cannot perform remote camera control operations (e.g., control camera of a remote room system). Restricted participant is muted by the conference server by default, and can only be unmuted by the moderator, e.g., by getting moderator's attention to be unmuted through raise hand mechanism.

- (CSCapability*) unassignAsLecturerCapability
| read nonatomic assign

Returns whether local user can unassign a participant as a lecturer.

The capability returns not supported if the conference call does not support deselection of a participant as the lecturer, or if the local user does not have permission to unset a participant as the lecturer on the call. Conference moderation capabilities are not supported when the client is used in shared control mode.

Returns
  capability information.

- (CSCapability*) unassignAsPresenterCapability
| read nonatomic assign

CSCapability object indicating whether deselecting a participant as the conference presenter is supported.

Conference moderation capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (CSCapability*) unblockParticipantVideoCapability
| read nonatomic assign

CSCapability object indicating whether unblock video of a selected participant is supported.

Conference video capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

- (CSCapability*) unmuteParticipantAudioCapability
| read nonatomic assign

CSCapability object indicating whether unmute of a selected participant is supported.

- (BOOL) videoActive
| read nonatomic assign

Whether the participant's video is active.

- (BOOL) videoBlockedByServer
| read nonatomic assign

Participant's video block (i.e., transmission) status, as known by the conferencing system.

- (int) videoChannelId
| read nonatomic assign

Video channel id associated with the video participant during a multi video stream conference call.

- (CSCapability*) videoPinCapability
| read nonatomic assign

CSCapability object indicating whether the local user can pin current participant's video in a specific position of the current video layout.

This capability returns not supported if the conference call does not support video pinning/unpinning, or video pin/unpin requests.

Conference moderation capabilities are not supported when the client is used in shared control mode. See CSSharedControlService.

See also
  pinVideo:completionHandler:

- (CSParticipantMediaStatus) videoStatus
| read nonatomic assign

Participant video state, as known by the conferencing system.

- (BOOL) wasPreviouslyNotVisibleInParticipantList
| read nonatomic assign

A Boolean value indicating that the active participant was on the conference but previously not visible in the conference roster.

This can happen when there are more participants on the conference call than what can be provided by the conference server in the roster.

When/if this hidden user becomes visible and gets added to the roster, the client can use this property to identify that this participant was already in the conference (and not just entering the meeting). The client application can use this property to update its UI accordingly: for example adding a special badge icon for this participant or adding the participant to a different list.

The documentation for this class was generated from the following file:

- CSActiveParticipant.h